<?php

namespace loyalsoft;

/**
 * Description of UserZoneInfoModel
 * 玩家分析信息数据结构，存储了玩家在游戏中曾经玩过的分区信息，
 * 玩家登陆成功后，首先取分区信息，服务器返回所有分区列表，并把玩家曾经玩过的分区信息
 * 提取出来传给玩家，包括上次玩过的分区，以及在各个分区中的等级信息。
 * @author gwang email:wanggangzero@qq.com
 * @version 1.0
 * @copyright © 2015-1-28, SJZ LoyalSoft Corporation & gwang. All rights reserved.
 * @History
 *   2015年1月28日 暂定玩家玩过的分区集合为 分区id:等级的关联数组，若是后期有要求提供
 * 更多信息（等级以外）再行修改。
 */
class Data_UserZoneInfo
{

    /**
     * 玩家玩过的分区集合(分区ID:等级,昵称)
     * @var array (ZoneInfoModel)
     */
    public $playedZones;

    /**
     * 玩家上次登录的分区信息
     * @var Ins_ZoneInfo
     */
    public $lastZone;

    public function __construct()
    {
        $this->playedZones = ObjectInit();
    }

}
